@echo off

echo ct-Suche nach Intel-Chipsaetzen mit bekannten Bugs ...

SETLOCAL EnableDelayedExpansion
for /F %%i in ('wmic idecontroller get deviceid') do ( 	
	rem jede Zeile durchgehen
	for /F "delims=\ tokens=2" %%x in ("%%i") do (
		rem interessant ist der Teilstring hinter dem "\"
		set s=%%x 	
		if "!s:~0,3!" == "VEN" (	rem Device-Eintrag bearbeiten
			set ven=!s:~4,4!
			set dev=!s:~13,4!
			set rev=!s:~38,2!
			
			rem Nur Intel-Hardware untersuchen (vendor=0x8086)
			if "!ven!" == "8086" (
				for %%d in (1C00 1C01 1C02 1C03 1C05 1C08 1C09) do (
					if "!dev!" == "%%d" (
						rem echo 	* Serie-6-Chipsatz gefunden. Erkannt an: !ven!:!dev!
						if "!rev!" == "04" (
							echo 	* B2-Stepping gefunden. Erkannt an: Revision: !rev!
							set affected=Serie 6 mit B2-Stepping !ven!:!dev!:!rev!
							set problems=SATA-Probleme siehe heise.de/-1181172
						) else (
							echo 	* kein B2-Stepping gefunden. Erkannt an: Revision: !rev!
						)
					)
				)
				for %%d in (8C00 8C01 8C02 8C03 8C04 2822 8C05 282A 8C06 2826 8C07 8C0E 8C0F)  do (
					if "!dev!" == "%%d" (
						echo 	* Serie-8-Chipsatz gefunden. Erkannt an: !ven!:!dev!
						if "!rev!" == "04" (
							echo 	* C1-Stepping gefunden. Erkannt an: Revision: !rev!
							set affected=Serie 8 mit C1-Stepping !ven!:!dev!:!rev!
							set problem=USB-3.0-Probleme siehe heise.de/-1835632
						) else (
							echo 	* kein C1-Stepping gefunden. Erkannt an: Revision: !rev!
						)
					)
				)

			)
			
		)
	)
)


echo Ergebnis:

if "%affected%" =="" (
	echo Entwarnung: Kein betroffener Intel-Chipsatz gefunden
) else (
	echo Achtung: Intel-Chipsatz der %affected% gefunden. 
	echo Ihr PC ist evtl. von Intels Chipsatz-Bug betroffen 
	echo Moeglich sind: %problem%
	echo Hinweis:
 	echo Sollte es sich um einen Business-Chipsatz aus der Q-Serie handeln, 
	echo kann es sein, dass er trotzdem nicht betroffen ist und nur per CRID 
	echo ein aelteres Stepping vorgaukelt
)

pause
